## qnodeeditor 2.1.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
# version 3.4 is required as other do not work with C++14 and clang

project(NodeEditor CXX)

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(CMAKE_DISABLE_SOURCE_CHANGES  ON)
set(CORE_VERSION "2")

get_directory_property(_has_parent PARENT_DIRECTORY)
if(_has_parent)
  set(is_root_project OFF)
else()
  set(is_root_project ON)
endif()

set(NE_DEVELOPER_DEFAULTS "${is_root_project}" CACHE BOOL "Turns on default settings for development of NodeEditor")

option(BUILD_TESTING "Build tests" "${NE_DEVELOPER_DEFAULTS}")
option(BUILD_EXAMPLES "Build Examples" "${NE_DEVELOPER_DEFAULTS}")
option(BUILD_SHARED_LIBS "Build as shared library" ON)
option(NE_FORCE_TEST_COLOR "Force colorized unit test output" OFF)

enable_testing()

if(NE_DEVELOPER_DEFAULTS)
  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_EXTENSIONS OFF)

  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
endif()

#add_subdirectory(external)

# Find the QtWidgets library
find_package(Qt5 5.3 COMPONENTS
             Core
             Widgets
             Gui)

qt5_add_resources(RESOURCES ./resources/resources.qrc)

# Unfortunately, as we have a split include/src, AUTOMOC doesn't work.
# We'll have to manually specify some files
set(CMAKE_AUTOMOC ON)

set(CPP_SOURCE_FILES
  src/Connection.cpp
  src/ConnectionBlurEffect.cpp
  src/ConnectionGeometry.cpp
  src/ConnectionGraphicsObject.cpp
  src/ConnectionPainter.cpp
  src/ConnectionState.cpp
  src/ConnectionStyle.cpp
  src/DataModelRegistry.cpp
  src/FlowScene.cpp
  src/FlowView.cpp
  src/FlowViewStyle.cpp
  src/Node.cpp
  src/NodeConnectionInteraction.cpp
  src/NodeDataModel.cpp
  src/NodeGeometry.cpp
  src/NodeGraphicsObject.cpp
  src/NodePainter.cpp
  src/NodeState.cpp
  src/NodeStyle.cpp
  src/Properties.cpp
  src/StyleCollection.cpp
)

# If we want to give the option to build a static library,
# set BUILD_SHARED_LIBS option to OFF
add_library(nodes
  ${CPP_SOURCE_FILES}
  ${RESOURCES}
)
add_library(NodeEditor::nodes ALIAS nodes)

set_target_properties(nodes PROPERTIES
  SOVERSION ${CORE_VERSION}
)

target_include_directories(nodes
  PUBLIC
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/nodes/internal>
)

target_link_libraries(nodes
  PUBLIC
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
)

target_compile_definitions(nodes
  PUBLIC
    ${Qt5Widgets_DEFINITIONS}
    NODE_EDITOR_SHARED
  PRIVATE
    NODE_EDITOR_EXPORTS
    #NODE_DEBUG_DRAWING
    QT_NO_KEYWORDS
)

target_compile_options(nodes
  PRIVATE
    $<$<CXX_COMPILER_ID:MSVC>:/W4 /wd4127 /EHsc>
    $<$<CXX_COMPILER_ID:GNU>:-Wall -Wextra>
    $<$<CXX_COMPILER_ID:Clang>:-Wall -Wextra>
)

target_compile_features(nodes
  PUBLIC
    cxx_generic_lambdas # Require C++14
)

set_target_properties(nodes
  PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
)

######
# Moc
##

file(GLOB_RECURSE HEADERS_TO_MOC include/nodes/internal/*.hpp)

qt5_wrap_cpp(nodes_moc
    ${HEADERS_TO_MOC}
  TARGET nodes
  OPTIONS --no-notes # Don't display a note for the headers which don't produce a moc_*.cpp
)

target_sources(nodes PRIVATE ${nodes_moc})

###########
# Examples
##

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

##################
# Automated Tests
##

if(BUILD_TESTING)
  #add_subdirectory(test)
endif()

###############
# Installation
##

include(GNUInstallDirs)

set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/NodeEditor)

install(TARGETS nodes
  EXPORT NodeEditorTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT NodeEditorTargets
  FILE NodeEditorTargets.cmake
  NAMESPACE NodeEditor::
  DESTINATION ${INSTALL_CONFIGDIR}
)

include(CMakePackageConfigHelpers)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/NodeEditorConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/NodeEditorConfig.cmake
  INSTALL_DESTINATION ${INSTALL_CONFIGDIR}
)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/NodeEditorConfig.cmake
  DESTINATION ${INSTALL_CONFIGDIR}
)

=== examples/CMakeLists.txt ===
add_subdirectory(connection_colors)

add_subdirectory(example2)

add_subdirectory(calculator)

add_subdirectory(images)

add_subdirectory(styles)

add_subdirectory(ff)

add_subdirectory(state_machine)

=== external/CMakeLists.txt ===
if(BUILD_TESTING)
  find_package(Catch2 2.3.0 QUIET)

  if(NOT Catch2_FOUND)
    add_subdirectory(Catch2)
  endif()
endif()

macro(find_package pkg)
  if(NOT TARGET "${pkg}")
    _find_package(${ARGV})
  endif()
endmacro()

=== test/CMakeLists.txt ===
find_package(Catch2 2.3.0 REQUIRED)
find_package(Qt5 COMPONENTS Test)

add_executable(test_nodes
  test_main.cpp
  src/TestDragging.cpp
  src/TestDataModelRegistry.cpp
  src/TestNodeGraphicsObject.cpp
  src/TestFlowScene.cpp
)

target_include_directories(test_nodes
  PRIVATE
    ../src
    ../include/internal
    include
)

target_link_libraries(test_nodes
  PRIVATE
    NodeEditor::nodes
    Catch2::Catch2
    Qt5::Test
)

add_test(
  NAME test_nodes
  COMMAND
    $<TARGET_FILE:test_nodes>
    $<$<BOOL:${NE_FORCE_TEST_COLOR}>:--use-colour=yes>
)

=== examples/calculator/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(calculator ${CPPS})

target_link_libraries(calculator nodes)

target_link_libraries(calculator -static-libgcc -static-libstdc++)

=== examples/connection_colors/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(connection_colors ${CPPS})

target_link_libraries(connection_colors nodes)

=== examples/example2/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(example2 ${CPPS})

target_link_libraries(example2 nodes)

=== examples/ff/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(ff ${CPPS})

find_package(Qt5 COMPONENTS
             Charts)

target_link_libraries(ff nodes Qt5::Charts)

=== examples/images/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(images ${CPPS})

target_link_libraries(images nodes)

=== examples/state_machine/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(state_machine ${CPPS})

target_link_libraries(state_machine nodes)

=== examples/styles/CMakeLists.txt ===
file(GLOB_RECURSE CPPS  ./*.cpp )

add_executable(styles ${CPPS})

target_link_libraries(styles nodes)

=== external/Catch2/CMakeLists.txt ===
if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/single_include/catch2/catch.hpp")
  file(DOWNLOAD https://raw.githubusercontent.com/catchorg/Catch2/v2.4.1/single_include/catch2/catch.hpp
    "${CMAKE_CURRENT_BINARY_DIR}/single_include/catch2/catch.hpp"
    EXPECTED_HASH SHA256=a4b90030cb813f0452bb00e97c92ca6c2ecf9386a2f000b6effb8e265a53959e
  )
endif()

add_library(Catch2 INTERFACE)
add_library(Catch2::Catch2 ALIAS Catch2)
target_include_directories(Catch2
  INTERFACE
    "${CMAKE_CURRENT_BINARY_DIR}/single_include"
)

## qnodeeditor 2.1.5+ds1

=== debian/changelog ===
qnodeeditor (2.1.5+ds1-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Feb 2020 01:07:28 -0500

=== debian/control ===
Source: qnodeeditor
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-exec,
 qtbase5-dev,
 qt5-qmake,
Standards-Version: 4.5.0
Homepage: https://github.com/lhy0403/QNodeEditor
Vcs-Git: https://salsa.debian.org/debian/qnodeeditor.git
Vcs-Browser: https://salsa.debian.org/debian/qnodeeditor

Package: libqnodeeditor-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libqnodeeditor2 (= ${binary:Version}),
 ${misc:Depends},
Description: Qt-based library for graph-controlled data processing (dev)
 NodeEditor is conceived as a general-purpose Qt-based library aimed
 at graph-controlled data processing. The library can be used as a
 framework for visual dataflow programming.
 .
 This package provides the development files.

Package: libqnodeeditor2
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Qt-based library for graph-controlled data processing
 NodeEditor is conceived as a general-purpose Qt-based library aimed
 at graph-controlled data processing. The library can be used as a
 framework for visual dataflow programming.
 .
 This package provides the library files.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := 5

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%qnodeeditor-$1.tar.gz%" \
 https://github.com/lhy0403/QNodeEditor/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## qnodeeditor 2.1.7

=== debian/changelog ===
qnodeeditor (2.1.7-1) unstable; urgency=medium

  [ Guobang Bi ]
  * New upstream release 2.1.7.

  [ Boyuan Yang ]
  * Switch to actively-maintained fork.
  * debian/control:
    + Use cmake instead of qmake following upstream.

 -- Boyuan Yang <byang@debian.org>  Sat, 30 May 2020 20:51:14 -0400

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- dh-exec,
+ cmake,
+ debhelper-compat (= 13),
  qtbase5-dev,
- qt5-qmake,
+ libqt5charts5-dev,
 Standards-Version: 4.5.0
-Homepage: https://github.com/lhy0403/QNodeEditor
+Homepage: https://github.com/Qv2ray/QNodeEditor
 Vcs-Git: https://salsa.debian.org/debian/qnodeeditor.git
 Vcs-Browser: https://salsa.debian.org/debian/qnodeeditor

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := 5

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%qnodeeditor-$1.tar.gz%" \
 https://github.com/Qv2ray/QNodeEditor/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
